use strict;
use warnings;

# @W[̓ǂݍ
use Time::Local 'timelocal';
use Getopt::Long 'GetOptions';

# Agp@
my $usage = "Usage: $0 --start=yyyymmdd:hhmmss --end=yyyymmdd:hhmmss FILE";

# BR}hCIvV
my $start = '';
my $end   = '';
GetOptions(
    'start=s' => \$start,
    'end=s'   => \$end
) or die $usage;


# C̃tH[}bg
my $format = qr/^(\d{4})(\d{2})(\d{2}):(\d{2})(\d{2})(\d{2})$/;

# DJniG|bNbj
my $start_epoch;
if ($start =~ /$format/) {
    my $year = $1;
    my $mon  = $2;
    my $mday = $3;
    
    my $hour = $4;
    my $min  = $5;
    my $sec  = $6;
    
    $start_epoch = timelocal($sec, $min, $hour, 
                             $mday, $mon - 1, $year - 1900);
}

# EIiG|bNbj
my $end_epoch;
if ($end =~ /$format/) {
    my $year = $1;
    my $mon  = $2;
    my $mday = $3;
    
    my $hour = $4;
    my $min  = $5;
    my $sec  = $6;
    
    $end_epoch = timelocal($sec, $min, $hour, 
                           $mday, $mon - 1, $year - 1900);
}

# Ft@C
my $file = shift;

# Ggp@̕\
die $usage
  unless $start && $end && $file;

# Ht@CI[v
open my $fh, '<', $file
  or die qq{Can't open file "$file": $!};

# Is̓ǂݍ
while (my $line = <$fh>) {

    # I-1 s̍폜
    chomp $line;
    
    # I-2 G|bNbɕϊ
    my $epoch;
    if ($line =~ m#^(\d{4})/(\d{2})/(\d{2}),(\d{2}):(\d{2}):(\d{2})$#) {
        my $year = $1;
        my $mon  = $2;
        my $mday = $3;
        
        my $hour = $4;
        my $min  = $5;
        my $sec  = $6;
        
        $epoch = timelocal($sec, $min, $hour, 
                           $mday, $mon - 1, $year - 1900);
    }
    
    # I-3 sȃtH[}bg
    die qq{Unexpected format: "$line"}
      unless defined $epoch;
    
    # I-4 }b`鎞̍ŝ݂o
    print "$line\n"
      if $epoch >= $start_epoch && $epoch < $end_epoch;
}

# Jt@CN[Y
close $fh;