package MemoryLog::Parser;

use strict;
use warnings;

# @NX̌p
use base 'Object::Simple';

# AW[̓ǂݍ
use Carp 'croak';

# BANZT̒`
__PACKAGE__->attr('total_memory');
__PACKAGE__->attr(header_exists => 1);

# Ct@C͂郁\bh
sub parse {
    my ($self, $file) = @_;
    
    # C-1 t@C̃I[v
    open my $fh, '<', $file
      or die qq{Can't open file "$file": $!};
    
    # C-2 gp̏
    my $infos = [];
    
    # C-3 es̓ǂݍ
    while (my $line = <$fh>) {
        
        # C-4 wb_݂Ƃ1sڂ΂
        next if $. == 1 && $self->header_exists;
        
        # C-5 s̍폜
        chomp $line;
        
        # C-6 ƃgpʂ擾
        my ($time, $avm) = split /\s+/, $line;
        
        # C-7 ̑
        my $total_memory = $self->total_memory;
        
        # C-8 ̑ʂ擾łȂƂ͗O𓊂
        croak "total_memory must be specify"
          unless defined $total_memory;
        
        # C-9 gp
        my $mem = $avm / $total_memory;
        
        # C-10 ǉ
        push @$infos, {time => $time, mem => $mem};
    }
    
    # Dt@C̃N[Y
    close $fh;

    return $infos;
}

# E^̒lԋp
1;